/* 

  wn.c - Command line interface to WordNet

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wn.h"
#include "wnhelp.h"
#include "license.h"

void main()
{
    int i, j = 1, pos, num;
    int whichsense = ALLSENSES, help = 0;
    char *searchword=(char *)malloc(20),
         *mword=(char *)malloc(20);
    SynsetPtr found, cur[10];  /* ⠢ ६ ࠭祭
                                    । */

    if (wninit()) {	/* open database */
	printf("wn: Fatal error - cannot open WordNet database\n");
	exit (-1);
    }
    num = 0;
    while (gets(searchword)) {
       // we don't know what is it
       for (pos=1; pos <= NUMPARTS; pos++) {
           if (pos == 1)  // it's a noun
            {
           printf("search HYPOPTR started... \n");
              found = findtheinfo_ds(searchword, pos, -HYPERPTR, ALLSENSES);
           printf("search HYPOPTR done... \n");
            }
           else
              found = findtheinfo_ds(searchword, pos, OVERVIEW, ALLSENSES);
           if (found == NULL) // try to morph
             {
                mword = morphword(searchword, NOUN);
                printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                  if (pos == 1)  // it's a noun
                     found = findtheinfo_ds(searchword, pos, -HYPERPTR, ALLSENSES);
                  else
                     found = findtheinfo_ds(searchword, pos, OVERVIEW, ALLSENSES);
             }
           if (found != NULL) {
               cur[num] = found;
               do {
                  printf("%D = { %s }\n", cur[num]->hereiam, cur[num]->defn);
                  if (cur[num]->ptrlist == NULL)
                              cur[num] = cur[num]->nextss;
                  else
                      cur[num] = cur[num]->ptrlist;
               } while (cur[num] != NULL);
           }
           else {
              printf("no match found\n");          
           }        
           printf("-------------\n");
       }  /* end for */
      printf("=====================\n");
    }
    free(mword);
    free(searchword);
}



